package loopbounds;

public class ExistingAnnotations {

	/*@
	 requires end > 0;
	 */
	public void methPre (int start, int end) {

		while (start<end) {
			start++;
		}
	}

	/*@
	 ensures start == end;
	 */
	public void methPost (int start, int end) {

		while (start<end) {
			start++;
		}
	}

	/*@
	 requires end > 0;
	 ensures start == end;
	 */
	public void methPreAndPost (int start, int end) {

		while (start<end) {
			start++;
		}
	}

	public void loopInvariant (int start, int end) {

		//@ loop_invariant start <= end;
		while (start<end) {
			start++;
		}
	}

	public void decreases (int start, int end) {

		//@ decreases end*2 - start;
		while (start<end) {
			start++;
		}
	}

	public void assignable (int start, int end) {

		//@ assignable start;
		while (start<end) {
			start++;
		}
	}

	public void loopAnnotations (int start, int end) {

		//@ loop_invariant start <= end;
		//@ assignable start;
		//@ decreases end*2 - start;
		while (start<end) {
			start++;
		}
	}

	/*@
	 requires end > 0;
	 ensures start == end;
	 */
	public void multiple (int start, int end) {

		//@ loop_invariant start <= end;
		//@ assignable start;
		//@ decreases end*2 - start;
		while (start<end) {
			start++;
		}
	}
}
